;------------------------------------------------------------------------------
;
;   ELF32 executable Binary Macro for NASM/YASM
;
;   %include "elf32.mac"
;
;------------------------------------------------------------------------------

; ELF Type
%define ELF_Linux		3
%define ELF_FreeBSD		9

; The ELF32 header macro
%macro	elf32_header 1				; arg: ELF TYPE
_elf_phdr_flags equ     7
	org     0x08048000

	db      0x7F, 'ELF'             ; e_ident
	db      1, 1, 1, %1				; ELF TYPE
    times 8 db      0
	dw		2						; e_type : Executable file
    dw      3                       ; e_machine : Intel 80386
	dd      1                       ; e_version : Current Version
    dd      _start 					; e_entry
    dd      _phdr - $$				; e_phoff (program header offset)
    dd      0                       ; e_shoff (section header offset)
	dd      0                       ; e_flags (Processor-Specific flags)
	dw      0x34					; e_ehsize (ELF header's size)
    dw      0x20					; e_phentsize
_phdr:
    dw      1                       ; e_phnum (program header entries number)
    dw      0                       ; e_shentsize (section header's size)
	dw      0                       ; e_shnum (section header entries number)
	dw      0						; e_shstrndx
	dd      $$						; p_vaddr (virtual address)
    dd      $$                      ; p_paddr
	dd      _elf_filesize			; p_filesz
	dd      _elf_filesize			; p_memsz
	dd      _elf_phdr_flags			; p_flags
	dd      0x1000					; p_align
%endmacro

; The ELF32 footer macro
%macro	elf32_footer	0
_elf_filesize	equ     $ - $$
%endmacro
